package adapter_test

import (
	"testing"

	"gitea.dwysokinski.me/twhelp/corev3/internal/adapter"
	"gitea.dwysokinski.me/twhelp/corev3/internal/adapter/adaptertest"
)

func TestVersionBunRepo_Postgres(t *testing.T) {
	t.Parallel()

	if testing.Short() {
		t.Skip("skipping long-running test")
	}

	testVersionRepo(t, func(t *testing.T) versionRepository {
		t.Helper()
		return adapter.NewVersionBunRepository(postgres.NewBunDB(t))
	})
}

func TestVersionBunRepo_SQLite(t *testing.T) {
	t.Parallel()

	testVersionRepo(t, func(t *testing.T) versionRepository {
		t.Helper()
		return adapter.NewVersionBunRepository(adaptertest.NewBunDBSQLite(t))
	})
}
