package domaintest

import (
	"net/url"

	"gitea.dwysokinski.me/twhelp/corev3/internal/domain"
	"github.com/brianvoe/gofakeit/v6"
	"github.com/stretchr/testify/require"
)

type BaseServerConfig struct {
	Key string
	URL *url.URL
}

func (cfg *BaseServerConfig) init() {
	if cfg.Key == "" {
		cfg.Key = gofakeit.LetterN(5)
	}

	if cfg.URL == nil {
		cfg.URL = &url.URL{
			Scheme: "https",
			Host:   cfg.Key + ".plemiona.pl",
		}
	}
}

func NewBaseServer(tb TestingTB, cfg BaseServerConfig) domain.BaseServer {
	cfg.init()
	s, err := domain.NewBaseServer(cfg.Key, cfg.URL.String(), true)
	require.NoError(tb, err)
	return s
}
