package migrations

import "github.com/uptrace/bun/dialect/feature"

type hasFeaturer interface {
	HasFeature(feat feature.Feature) bool
}

func autoIncrement(f hasFeaturer) string {
	if f.HasFeature(feature.GeneratedIdentity) {
		return "GENERATED BY DEFAULT AS IDENTITY"
	}
	if f.HasFeature(feature.AutoIncrement) {
		return "AUTO_INCREMENT"
	}
	return ""
}
